__gnu_cxx::__alloc_traits< _Alloc > Struct Template Reference
Allocators
Inheritance diagram for __gnu_cxx::__alloc_traits< _Alloc >:
[legend]

## Public Types

typedef std::allocator_traits < _Alloc > | _Base_type
typedef _Alloc | allocator_type
typedef _Base_type::const_pointer | const_pointer
typedef const value_type & | const_reference
typedef __const_void_pointer | const_void_pointer
typedef _Base_type::difference_type | difference_type
typedef _Base_type::pointer | pointer
typedef __propagate_on_container_copy_assignment | propagate_on_container_copy_assignment
typedef __propagate_on_container_move_assignment | propagate_on_container_move_assignment
typedef __propagate_on_container_swap | propagate_on_container_swap
template<typename _Tp >
using | rebind_alloc = typename __alloctr_rebind< _Alloc, _Tp >::__type
template<typename _Tp >
using | rebind_traits = allocator_traits< rebind_alloc< _Tp >>
typedef value_type & | reference
typedef _Base_type::size_type | size_type
typedef _Base_type::value_type | value_type
typedef __void_pointer | void_pointer

## Static Public Member Functions

static constexpr bool | _S_always_equal ()
static constexpr bool | _S_nothrow_move ()
static constexpr bool | _S_nothrow_swap ()
static void | _S_on_swap (_Alloc &__a, _Alloc &__b)
static constexpr bool | _S_propagate_on_copy_assign ()
static constexpr bool | _S_propagate_on_move_assign ()
static constexpr bool | _S_propagate_on_swap ()
static _Alloc | _S_select_on_copy (const _Alloc &__a)
static pointer | allocate (_Alloc &__a, size_type __n)
static pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
template<typename _Ptr , typename... _Args>
static std::enable_if < __is_custom_pointer< _Ptr > ::value >::type | construct (_Alloc &__a, _Ptr __p, _Args &&...__args)
template<typename _Tp , typename... _Args>
static auto | construct (_Alloc &__a, _Tp *__p, _Args &&...__args) -> decltype(_S_construct(__a, __p, std::forward< _Args >(__args)...))
static void | deallocate (_Alloc &__a, pointer __p, size_type __n)
template<typename _Ptr >
static std::enable_if < __is_custom_pointer< _Ptr > ::value >::type | destroy (_Alloc &__a, _Ptr __p)
template<class _Tp >
static void | destroy (_Alloc &__a, _Tp *__p)
static size_type | max_size (const _Alloc &__a) noexcept
static _Alloc | select_on_container_copy_construction (const _Alloc &__rhs)

## Detailed Description

### template<typename _Alloc>
struct __gnu_cxx::__alloc_traits< _Alloc >

Uniform interface to C++98 and C++0x allocators.

Definition at line 95 of file ext/alloc_traits.h.

## Member Typedef Documentation

template<typename _Alloc>

typedef __const_void_pointer std::allocator_traits< _Alloc >::const_void_pointer

inherited

The allocator's const void pointer type.

`Alloc::const_void_pointer` if that type exists, otherwise `pointer_traits<pointer>::rebind<const void>`

Definition at line 135 of file bits/alloc_traits.h.

template<typename _Alloc>

typedef __propagate_on_container_copy_assignment std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment

inherited

How the allocator is propagated on copy assignment.

`Alloc::propagate_on_container_copy_assignment` if that type exists, otherwise `false_type`

Definition at line 169 of file bits/alloc_traits.h.

template<typename _Alloc>

typedef __propagate_on_container_move_assignment std::allocator_traits< _Alloc >::propagate_on_container_move_assignment

inherited

How the allocator is propagated on move assignment.

`Alloc::propagate_on_container_move_assignment` if that type exists, otherwise `false_type`

Definition at line 181 of file bits/alloc_traits.h.

template<typename _Alloc>

typedef __propagate_on_container_swap std::allocator_traits< _Alloc >::propagate_on_container_swap

inherited

How the allocator is propagated on swap.

`Alloc::propagate_on_container_swap` if that type exists, otherwise `false_type`

Definition at line 192 of file bits/alloc_traits.h.

template<typename _Alloc>

typedef __void_pointer std::allocator_traits< _Alloc >::void_pointer

inherited

The allocator's void pointer type.

`Alloc::void_pointer` if that type exists, otherwise `pointer_traits<pointer>::rebind<void>`

Definition at line 124 of file bits/alloc_traits.h.

## Member Function Documentation

template<typename _Alloc>

static pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n
| ) |  |

inlinestaticinherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 356 of file bits/alloc_traits.h.

template<typename _Alloc>

static pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n,
|  | const_void_pointer | __hint
| ) |  |

inlinestaticinherited

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns `a.allocate(n, hint)` if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 371 of file bits/alloc_traits.h.

template<typename _Alloc>
template<typename _Tp , typename... _Args>

static auto std::allocator_traits< _Alloc >::construct | ( | _Alloc & | __a,
|  | _Tp * | __p,
|  | _Args &&... | __args
| ) |  | -> decltype(_S_construct(__a, __p, std::forward<_Args>(__args)...))

inlinestaticinherited

Construct an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to memory of suitable size and alignment for Tp
  __args | Constructor arguments.

Calls `__a.construct(__p, std::forward<Args>(__args)...)` if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 397 of file bits/alloc_traits.h.

template<typename _Alloc>

static void std::allocator_traits< _Alloc >::deallocate | ( | _Alloc & | __a,
|  | pointer | __p,
|  | size_type | __n
| ) |  |

inlinestaticinherited

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls `a.deallocate(p, n)`

Definition at line 382 of file bits/alloc_traits.h.

template<typename _Alloc>
template<class _Tp >

static void std::allocator_traits< _Alloc >::destroy | ( | _Alloc & | __a,
|  | _Tp * | __p
| ) |  |

inlinestaticinherited

Destroy an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to the object to destroy

Calls `__a.destroy(__p)` if that expression is well-formed, otherwise calls `__p->~_Tp()`

Definition at line 410 of file bits/alloc_traits.h.

template<typename _Alloc>

static size_type std::allocator_traits< _Alloc >::max_size | ( | const _Alloc & | __a | ) |

inlinestaticnoexceptinherited

The maximum supported allocation size.

Parameters

  __a | An allocator.

Returns
  `__a.max_size()` or `numeric_limits<size_type>::max()`

Returns `__a.max_size()` if that expression is well-formed, otherwise returns `numeric_limits<size_type>::max()`

Definition at line 421 of file bits/alloc_traits.h.

Referenced by std::forward_list< _Tp, _Alloc >::max_size().

template<typename _Alloc>

static _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction | ( | const _Alloc & | __rhs | ) |

inlinestaticinherited

Obtain an allocator to use when copying a container.

Parameters

  __rhs | An allocator.

Returns
  `__rhs.select_on_container_copy_construction()` or __rhs

Returns `__rhs.select_on_container_copy_construction()` if that expression is well-formed, otherwise returns __rhs

Definition at line 433 of file bits/alloc_traits.h.

The documentation for this struct was generated from the following file:

- ext/alloc_traits.h